#define _GNU_SOURCE
#include <unistd.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/time.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
	pid_t tid;
	int i = 0;
	float avg_read_time = 0;
	struct timeval tv1, tv2;
	float avg_syscall_time = 0;
	unsigned int dummy;

	for (i = 0; i < 1000; i++) {
		gettimeofday(&tv1, NULL);		
		gettimeofday(&tv2, NULL);		
		avg_read_time += (tv2.tv_sec*1e6 + tv2.tv_usec - tv1.tv_sec*1e6 - tv1.tv_usec);
	}

	printf("avg_read_time: %f\n", avg_read_time/1000.0);

	for (i = 0; i < 100; i++) {
		gettimeofday(&tv1, NULL);		
		syscall(SYS_tgkill, getpid(), tid, SIGHUP);
		gettimeofday(&tv2, NULL);		
		dummy += (tv2.tv_sec*1e6 + tv2.tv_usec - tv1.tv_sec*1e6 - tv1.tv_usec);
		avg_syscall_time += dummy;
		printf("avg_syscall_time: %u\n", dummy);
		avg_syscall_time -= avg_read_time;
	}
	printf("avg_syscall_time: %f\n", avg_syscall_time/100.0);
	return 0;
}
