#include<stdio.h>
#include <sys/time.h>
#include <stdlib.h>

#define KB 1024
#define MB 1024 * KB
#define MAX_ITERATIONS 1000000
#define STRIDE_SIZE 16
#define CPU_FREQ 900

unsigned long long func(int size, int stride_size){
	struct timeval start, end;
	struct timezone tz;
	unsigned long long time1, time2;
	int j;
	int *array = (int *)malloc(size);
	int len = (size)/sizeof(int);
	unsigned int i;
	for(i=0; i < MAX_ITERATIONS; i++) {
		array[( i * stride_size) % len] =  array[( i * stride_size) % len]+i;
	}

	//gettimeofday(&start, NULL);
	asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (time1));
	for(i=0; i < MAX_ITERATIONS; i++) {
		j = array[( i * stride_size) % len];
	}
	//gettimeofday(&end, NULL);
	asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (time2));

	free(array);
	return time2 - time1;
	//return (-start.tv_sec*1e6-start.tv_usec+end.tv_sec*1e6+end.tv_usec);
}

int main()
{
	int i, j;

	for (j = 16; j <= 1024; j*=2) {
		printf("Stride size: %u\n", j);
		for (i = 1024; i <= 32 * MB; i*=2) {
			unsigned long long access_time = func(i, j);
			//unsigned overhead = 10;
			//multiply access time by 1000 to convert to ns
			//double avg = (access_time * 1.111)/(MAX_ITERATIONS);
			double avg = (access_time * 1000.0)/(MAX_ITERATIONS);
			printf("Size: %uKB access: %lluus, avg: %gns\n", i >> 10, access_time, avg);
		}
	}
	return 0;
}
