#include "../rasperf.h"
#include<stdio.h>
#include<stdlib.h>
#include<arpa/inet.h>
#include<sys/types.h>
#include<sys/wait.h>
#include<sys/socket.h>
#include<netdb.h>
#include<string.h>

//Macro definitions
#define handle_error(msg) \
    do { perror(msg); exit(1);} while(0);
#define LISTEN_BACKLOG 100
#define BUFFER_SIZE 5 * MB
#define MB 1024*1024
#define STRIDE_SIZE 64
#define BACKLOG 64

int main(int argc, char*argv[])
{   
    int socket_fd, rc;
    char buff[BUFFER_SIZE];
    float setup_delta, close_delta;
    if(argc<1){
        handle_error("<usage>:tcp_server");
    }
    //Retrieve the protocol number mapping 
    //from /etc/protocols file
    struct protoent *proto_entry;
    proto_entry = getprotobyname("tcp");
    
    //Open an socket end-point for this TCP Server
    socket_fd = socket(AF_INET, SOCK_STREAM, proto_entry->p_proto);
    if(socket_fd == -1){
        handle_error("Socket descriptor creation failed");
    }

    //My address information to bind to
    struct sockaddr_in sock_addr;
    memset(&sock_addr, 0, sizeof(struct sockaddr));
    sock_addr.sin_family = AF_INET;
    sock_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    sock_addr.sin_port = htons(8000);


    rc = bind(socket_fd, (struct sockaddr*)&sock_addr, sizeof(sock_addr)); 
    if(rc == -1){
        handle_error("Bind failure");
    }
    rc = listen(socket_fd, LISTEN_BACKLOG); 
    if(rc == -1){
        handle_error(" Listen Error");
    }

    time starttime, endtime;
    //accept incoming connections
    int connfd, i, pid, addr_size = sizeof(struct sockaddr);
    printf("Accept Connection\n");
    connfd = accept(socket_fd, (struct sockaddr *)NULL, NULL);
    if( connfd == -1){
        handle_error("Accept failed");
    }    
    
    getTime(starttime);    
    for(i=1;i<=BACKLOG;i++)
    {
        if(recv(connfd, buff,BUFFER_SIZE, 0) == -1){
            handle_error("Receive Error/ Data Done");
        }
    }
    getTime(endtime);
        
    close(socket_fd);
    close(connfd);
    printf("Data Receided:%d MB, Time:%f s \n",i*BUFFER_SIZE, diff(endtime, starttime));
    return 0;
}
   

