/* 
 * cswitch.c --
 *
 *	Simple program to test context switching by sending short
 *	messages back and forth through a pipe.  Invocation:
 *	
 *	cswitch count
 *
 *	Count tells how many times a one-byte message should be sent
 *	back and forth between two processes.
 *
 * Copyright 1987, 1989 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

#include <stdio.h>
int count, i, toSlave[2], fromSlave[2];

void *fn1()
{
	char buffer[10];
	unsigned int end;
	write(fromSlave[1], "a", 1);
	while (1) {
		read(toSlave[0], buffer, 1);
		asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (end));
		printf("end: %u\n", end);
		if (buffer[0] != 'a') {
			return NULL;
		}
		//write(fromSlave[1], "a", 1);
	}
}

void *fn2()
{
	unsigned int begin;
	char buffer[10];
	read(fromSlave[0], buffer, 1);
    for (i = 0; i < count; i++) {
		asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (begin));
		write(toSlave[1], "a", 1);
		//read(fromSlave[0], buffer, 1);
		printf("Start: %u\n", begin);
//		usleep(10000);
    }
    write(toSlave[1], "b", 1);
}

int main(int argc, char **argv)
{
    int pid;
    char buffer[10];
    unsigned int begin ,end;
    double timePer;
	unsigned int regr;
	int thread1, thread2;
	asm volatile("mrc p15, 0, %0, c9, c14, 0" : "=r" (regr));
	printf("regr: %x\n", regr);

	count = 10;
    pipe(toSlave);
    pipe(fromSlave);
	if(pthread_create(&thread1, NULL, &fn1, NULL)) {
		printf("1 not created\n");
		exit(1);
	}

   	if(pthread_create(&thread2, NULL, &fn2, NULL)) {
		printf("2 not created\n");
		exit(1);
	}
	pthread_join(thread1, NULL);
    pthread_join(thread2, NULL);
	return 0;
}
